
package net.mcreator.otherarmor.fluid;

import net.minecraftforge.fluids.ForgeFlowingFluid;
import net.minecraftforge.fluids.FluidAttributes;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;
import net.minecraft.resources.ResourceLocation;

import net.mcreator.otherarmor.init.OtherArmorModItems;
import net.mcreator.otherarmor.init.OtherArmorModFluids;
import net.mcreator.otherarmor.init.OtherArmorModBlocks;

public abstract class ACIDFluid extends ForgeFlowingFluid {
	public static final ForgeFlowingFluid.Properties PROPERTIES = new ForgeFlowingFluid.Properties(() -> OtherArmorModFluids.ACID,
			() -> OtherArmorModFluids.FLOWING_ACID,
			FluidAttributes.builder(new ResourceLocation("other_armor:blocks/acid1"), new ResourceLocation("other_armor:blocks/acid1"))

	).explosionResistance(100f)

			.bucket(() -> OtherArmorModItems.ACID_BUCKET).block(() -> (LiquidBlock) OtherArmorModBlocks.ACID);

	private ACIDFluid() {
		super(PROPERTIES);
	}

	public static class Source extends ACIDFluid {
		public Source() {
			super();
			setRegistryName("acid");
		}

		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends ACIDFluid {
		public Flowing() {
			super();
			setRegistryName("flowing_acid");
		}

		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
