
package net.mcreator.otherarmor.fluid;

import net.minecraftforge.fluids.ForgeFlowingFluid;
import net.minecraftforge.fluids.FluidAttributes;

import net.minecraft.world.phys.Vec3;
import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;
import net.minecraft.world.level.BlockGetter;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.core.BlockPos;

import net.mcreator.otherarmor.init.OtherArmorModItems;
import net.mcreator.otherarmor.init.OtherArmorModFluids;
import net.mcreator.otherarmor.init.OtherArmorModBlocks;

public abstract class HolywaterFluid extends ForgeFlowingFluid {
	public static final ForgeFlowingFluid.Properties PROPERTIES = new ForgeFlowingFluid.Properties(() -> OtherArmorModFluids.HOLYWATER,
			() -> OtherArmorModFluids.FLOWING_HOLYWATER,
			FluidAttributes.builder(new ResourceLocation("other_armor:blocks/holywater"), new ResourceLocation("other_armor:blocks/holywater"))

	).explosionResistance(100f)

			.tickRate(7)

			.bucket(() -> OtherArmorModItems.HOLYWATER_BUCKET).block(() -> (LiquidBlock) OtherArmorModBlocks.HOLYWATER);

	private HolywaterFluid() {
		super(PROPERTIES);
	}

	@Override
	public Vec3 getFlow(BlockGetter world, BlockPos pos, FluidState fluidstate) {
		return super.getFlow(world, pos, fluidstate).scale(1.5);
	}

	public static class Source extends HolywaterFluid {
		public Source() {
			super();
			setRegistryName("holywater");
		}

		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends HolywaterFluid {
		public Flowing() {
			super();
			setRegistryName("flowing_holywater");
		}

		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
