
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.otherarmor.init;

import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.world.BiomeLoadingEvent;
import net.minecraftforge.event.RegistryEvent;

import net.minecraft.world.level.levelgen.feature.Feature;
import net.minecraft.world.level.levelgen.feature.ConfiguredFeature;
import net.minecraft.world.level.levelgen.GenerationStep;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.data.BuiltinRegistries;
import net.minecraft.core.Registry;

import net.mcreator.otherarmor.world.features.lakes.HolywaterFeature;
import net.mcreator.otherarmor.world.features.lakes.ACIDFeature;
import net.mcreator.otherarmor.world.features.BossaltarFeature;
import net.mcreator.otherarmor.world.features.AngelaltarFeature;

import java.util.Set;
import java.util.Map;
import java.util.HashMap;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
public class OtherArmorModFeatures {
	private static final Map<Feature<?>, FeatureRegistration> REGISTRY = new HashMap<>();
	static {
		REGISTRY.put(ACIDFeature.FEATURE,
				new FeatureRegistration(GenerationStep.Decoration.LAKES, ACIDFeature.GENERATE_BIOMES, ACIDFeature.CONFIGURED_FEATURE));
		REGISTRY.put(HolywaterFeature.FEATURE,
				new FeatureRegistration(GenerationStep.Decoration.LAKES, HolywaterFeature.GENERATE_BIOMES, HolywaterFeature.CONFIGURED_FEATURE));
		REGISTRY.put(BossaltarFeature.FEATURE, new FeatureRegistration(GenerationStep.Decoration.SURFACE_STRUCTURES, BossaltarFeature.GENERATE_BIOMES,
				BossaltarFeature.CONFIGURED_FEATURE));
		REGISTRY.put(AngelaltarFeature.FEATURE, new FeatureRegistration(GenerationStep.Decoration.SURFACE_STRUCTURES,
				AngelaltarFeature.GENERATE_BIOMES, AngelaltarFeature.CONFIGURED_FEATURE));
	}

	@SubscribeEvent
	public static void registerFeature(RegistryEvent.Register<Feature<?>> event) {
		event.getRegistry().registerAll(REGISTRY.keySet().toArray(new Feature[0]));
		REGISTRY.forEach((feature, registration) -> Registry.register(BuiltinRegistries.CONFIGURED_FEATURE, feature.getRegistryName(),
				registration.configuredFeature()));
	}

	@Mod.EventBusSubscriber
	private static class BiomeFeatureLoader {
		@SubscribeEvent
		public static void addFeatureToBiomes(BiomeLoadingEvent event) {
			for (FeatureRegistration registration : REGISTRY.values()) {
				if (registration.biomes() == null || registration.biomes().contains(event.getName())) {
					event.getGeneration().getFeatures(registration.stage()).add(() -> registration.configuredFeature());
				}
			}
		}
	}

	private static record FeatureRegistration(GenerationStep.Decoration stage, Set<ResourceLocation> biomes,
			ConfiguredFeature<?, ?> configuredFeature) {
	}
}
