
package net.mcreator.otherarmor.item;

import net.minecraftforge.registries.ForgeRegistries;

import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ArmorMaterial;
import net.minecraft.world.item.ArmorItem;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.Entity;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.resources.ResourceLocation;

import net.mcreator.otherarmor.init.OtherArmorModTabs;

public abstract class AngelicItem extends ArmorItem {
	public AngelicItem(EquipmentSlot slot, Item.Properties properties) {
		super(new ArmorMaterial() {
			@Override
			public int getDurabilityForSlot(EquipmentSlot slot) {
				return new int[]{13, 15, 16, 11}[slot.getIndex()] * 25;
			}

			@Override
			public int getDefenseForSlot(EquipmentSlot slot) {
				return new int[]{20, 30, 30, 20}[slot.getIndex()];
			}

			@Override
			public int getEnchantmentValue() {
				return 9;
			}

			@Override
			public SoundEvent getEquipSound() {
				return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation(""));
			}

			@Override
			public Ingredient getRepairIngredient() {
				return Ingredient.of(new ItemStack(Items.FEATHER));
			}

			@Override
			public String getName() {
				return "angelic";
			}

			@Override
			public float getToughness() {
				return 1f;
			}

			@Override
			public float getKnockbackResistance() {
				return 1f;
			}
		}, slot, properties);
	}

	public static class Helmet extends AngelicItem {
		public Helmet() {
			super(EquipmentSlot.HEAD, new Item.Properties().tab(OtherArmorModTabs.TAB_EATHER));
			setRegistryName("angelic_helmet");
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "other_armor:textures/models/armor/iron__layer_1.png";
		}
	}

	public static class Chestplate extends AngelicItem {
		public Chestplate() {
			super(EquipmentSlot.CHEST, new Item.Properties().tab(OtherArmorModTabs.TAB_EATHER));
			setRegistryName("angelic_chestplate");
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "other_armor:textures/models/armor/iron__layer_1.png";
		}
	}

	public static class Leggings extends AngelicItem {
		public Leggings() {
			super(EquipmentSlot.LEGS, new Item.Properties().tab(OtherArmorModTabs.TAB_EATHER));
			setRegistryName("angelic_leggings");
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "other_armor:textures/models/armor/iron__layer_2.png";
		}
	}

	public static class Boots extends AngelicItem {
		public Boots() {
			super(EquipmentSlot.FEET, new Item.Properties().tab(OtherArmorModTabs.TAB_EATHER));
			setRegistryName("angelic_boots");
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "other_armor:textures/models/armor/iron__layer_1.png";
		}
	}
}
