
package net.mcreator.otherarmor.item;

import net.minecraftforge.registries.ForgeRegistries;

import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ArmorMaterial;
import net.minecraft.world.item.ArmorItem;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.Entity;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.resources.ResourceLocation;

import net.mcreator.otherarmor.init.OtherArmorModTabs;

public abstract class AngelskinItem extends ArmorItem {
	public AngelskinItem(EquipmentSlot slot, Item.Properties properties) {
		super(new ArmorMaterial() {
			@Override
			public int getDurabilityForSlot(EquipmentSlot slot) {
				return new int[]{13, 15, 16, 11}[slot.getIndex()] * 25;
			}

			@Override
			public int getDefenseForSlot(EquipmentSlot slot) {
				return new int[]{40, 50, 50, 40}[slot.getIndex()];
			}

			@Override
			public int getEnchantmentValue() {
				return 9;
			}

			@Override
			public SoundEvent getEquipSound() {
				return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation(""));
			}

			@Override
			public Ingredient getRepairIngredient() {
				return Ingredient.EMPTY;
			}

			@Override
			public String getName() {
				return "angelskin";
			}

			@Override
			public float getToughness() {
				return 10f;
			}

			@Override
			public float getKnockbackResistance() {
				return 0f;
			}
		}, slot, properties);
	}

	public static class Helmet extends AngelskinItem {
		public Helmet() {
			super(EquipmentSlot.HEAD, new Item.Properties().tab(OtherArmorModTabs.TAB_EATHER));
			setRegistryName("angelskin_helmet");
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "other_armor:textures/models/armor/eather__layer_1.png";
		}
	}

	public static class Chestplate extends AngelskinItem {
		public Chestplate() {
			super(EquipmentSlot.CHEST, new Item.Properties().tab(OtherArmorModTabs.TAB_EATHER));
			setRegistryName("angelskin_chestplate");
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "other_armor:textures/models/armor/eather__layer_1.png";
		}
	}

	public static class Leggings extends AngelskinItem {
		public Leggings() {
			super(EquipmentSlot.LEGS, new Item.Properties().tab(OtherArmorModTabs.TAB_EATHER));
			setRegistryName("angelskin_leggings");
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "other_armor:textures/models/armor/eather__layer_2.png";
		}
	}

	public static class Boots extends AngelskinItem {
		public Boots() {
			super(EquipmentSlot.FEET, new Item.Properties().tab(OtherArmorModTabs.TAB_EATHER));
			setRegistryName("angelskin_boots");
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "other_armor:textures/models/armor/eather__layer_1.png";
		}
	}
}
