
package net.mcreator.otherarmor.item;

import net.minecraftforge.registries.ForgeRegistries;

import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ArmorMaterial;
import net.minecraft.world.item.ArmorItem;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.Entity;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.resources.ResourceLocation;

import net.mcreator.otherarmor.init.OtherArmorModTabs;

public abstract class EmpoweredcorruptedrubyItem extends ArmorItem {
	public EmpoweredcorruptedrubyItem(EquipmentSlot slot, Item.Properties properties) {
		super(new ArmorMaterial() {
			@Override
			public int getDurabilityForSlot(EquipmentSlot slot) {
				return new int[]{13, 15, 16, 11}[slot.getIndex()] * 35;
			}

			@Override
			public int getDefenseForSlot(EquipmentSlot slot) {
				return new int[]{14, 22, 22, 14}[slot.getIndex()];
			}

			@Override
			public int getEnchantmentValue() {
				return 10;
			}

			@Override
			public SoundEvent getEquipSound() {
				return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation(""));
			}

			@Override
			public Ingredient getRepairIngredient() {
				return Ingredient.of(new ItemStack(Blocks.LILY_PAD));
			}

			@Override
			public String getName() {
				return "empoweredcorruptedruby";
			}

			@Override
			public float getToughness() {
				return 10f;
			}

			@Override
			public float getKnockbackResistance() {
				return 5f;
			}
		}, slot, properties);
	}

	public static class Helmet extends EmpoweredcorruptedrubyItem {
		public Helmet() {
			super(EquipmentSlot.HEAD, new Item.Properties().tab(OtherArmorModTabs.TAB_DON_DESOLUTION));
			setRegistryName("empoweredcorruptedruby_helmet");
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "other_armor:textures/models/armor/diamond__layer_1.png";
		}
	}

	public static class Chestplate extends EmpoweredcorruptedrubyItem {
		public Chestplate() {
			super(EquipmentSlot.CHEST, new Item.Properties().tab(OtherArmorModTabs.TAB_DON_DESOLUTION));
			setRegistryName("empoweredcorruptedruby_chestplate");
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "other_armor:textures/models/armor/diamond__layer_1.png";
		}
	}

	public static class Leggings extends EmpoweredcorruptedrubyItem {
		public Leggings() {
			super(EquipmentSlot.LEGS, new Item.Properties().tab(OtherArmorModTabs.TAB_DON_DESOLUTION));
			setRegistryName("empoweredcorruptedruby_leggings");
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "other_armor:textures/models/armor/diamond__layer_2.png";
		}
	}

	public static class Boots extends EmpoweredcorruptedrubyItem {
		public Boots() {
			super(EquipmentSlot.FEET, new Item.Properties().tab(OtherArmorModTabs.TAB_DON_DESOLUTION));
			setRegistryName("empoweredcorruptedruby_boots");
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "other_armor:textures/models/armor/diamond__layer_1.png";
		}
	}
}
